/*
 * mp3plot - Bitrate analysis tool
 *
 * Copyright (C) 2007, 2009 Toni Corvera
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#if defined(_WIN32) || defined(_WIN64) // See win.h too

// This file is provided as an alternative to the autotools-generated
// config.h for windows systems

#include "../config.h" // base values

#ifdef _MSC_VER
// temporarily disable the "macro redefinition message", XXX: should actually
// undefined them at some point
#   pragma warning ( disable : 4005 )
#endif

// Boost IS required anyway...
#define HAVE_BOOST 
#define HAVE_BOOST_PROGRAM_OPTIONS 
#define HAVE_BOOST_SHARED_PTR_HPP
#define HAVE_BOOST_THREAD 
#undef HAVE_TR1_MEMORY // No support for TR1 yet

// Undefine if GD is not available
#define HAVE_GD 1

#if HAVE_GD == 1
#   define HAVE_GDFONTL_H 1
#   define HAVE_GD_H 1
#endif

// Redefine if Magick++ is available
#undef HAVE_MAGICKPP
#undef HAVE_GRAPHICSMAGICKPP
#undef HAVE_IMAGEMAGICKPP
#if defined(HAVE_GD) || defined(HAVE_MAGICKPP)
#   define HAVE_GRAPHICS_SUPPORT 1
#endif

// No inttypes nor stdint are provided in MSVC
#undef HAVE_INTTYPES_H
#undef HAVE_STDINT_H

// C include files, should be provided
#define STDC_HEADERS 1
#define HAVE_MEMORY_H 1
#define HAVE_STDLIB_H 1
#define HAVE_STRING_H 1
#define HAVE_SYS_TYPES_H 1

// POSIX & pals includes
#undef HAVE_SYSEXITS_H

#ifdef _MSC_VER
// re-enable macro redefinition warning, see remarks above
#   pragma warning ( default : 4005 )
#endif

#else
#   error This file should only be included in Windows systems
#endif // windows
// vim:set ts=4 et ai: //
