/*
 * mp3plot - Bitrate analysis tool
 *
 * Copyright (C) 2009 Toni Corvera
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

// $Id: colourscheme.inc.cc 1700 2009-04-24 19:06:20Z  $
/*
 * File automatically generated by the colourschemegen.pl script, part of mp3plot.
 * This file is meant to be '#included' by image_plotter.cc (although it should
 * also compile by itself).
 * See the colourschemegen.pl script for details on how to (re-)generate this file.
 *
 * Command-line used to generate this file: colourschemegen.pl 400000 1 R
 */
#include "../common.h"
#include "../mp3/bitrate.h"
#include "colour.h"

#include <cassert>
#include <vector>
#include <map>

#include <iostream>

namespace mp3plot {
namespace impl {
namespace colourscheme {

using namespace std;
using namespace net_outlyer;

const map<bitrate_t, rgb_type>& get_map() {
	static map<bitrate_t, rgb_type> m;

	if (m.empty()) {
		typedef colour_type<int, 255> ict;
		bitrate_t idx;
		const vector<bitrate_t> & brs = mp3::standard_bitrates::as_vector();
		vector<bitrate_t>::const_iterator it = brs.begin();
		// Free-form
		m.insert( make_pair(*it++, rgb_type(1)) );

		// Standard bitrates
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(64,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(79,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(93,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(108,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(123,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(137,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(152,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(167,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(182,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(196,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(211,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(226,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(240,0,0).convert<double,1>()) );
		idx = *it++;
		assert( it != brs.end() );
		m.insert( make_pair(idx, ict(255,0,0).convert<double,1>()) );

		// Bad bitrate
		m.insert( make_pair(mp3::standard_bitrates::bad_bitrate(), ict(128).convert<double,1>()) );
	}

	return m;
}

} // ns colourscheme
} // ns impl
} // ns mp3plot

